## samba4 4.0.0~rc5+dfsg1

=== debian/changelog ===
samba4 (4.0.0~rc5+dfsg1-1ubuntu2) raring; urgency=low

  * Add 12_waf_python_config.patch: Do not assume that python*-config is a
    Python script; just call it as an executable. Fixes FTBFS with latest
    python2.7 which changed python2.7-config from a Python to a Shell script. 

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 13 Dec 2012 18:22:13 +0100

samba4 (4.0.0~rc5+dfsg1-1ubuntu1) raring; urgency=low

  * debian/tests/control: Fix dependency: python-samba4 does not exist, it's
    python-samba.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 13 Dec 2012 16:27:20 +0100

samba4 (4.0.0~rc5+dfsg1-1) experimental; urgency=low

  * New upstream release.
  * Add autopkgtest header. Closes: #692671
  * Use Multi-Arch for winbind4.

 -- Jelmer Vernooij <jelmer@debian.org>  Thu, 08 Nov 2012 15:13:43 +0100

samba4 (4.0.0~rc4+dfsg1-1) experimental; urgency=low

  * New upstream release.
   + Bump minimum ldb version to 1.1.13.
  * Switch to Git as VCS.
  * Remove DM-Upload-Allowed field.
  * Depend on heimdal-multidev rather than heimdal-dev.
   + Add 11_system_heimdal to support building with system heimdal.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 28 Oct 2012 16:21:43 +0100

samba4 (4.0.0~rc3+dfsg1-1) experimental; urgency=low

  * New upstream release.

 -- Jelmer Vernooij <jelmer@debian.org>  Tue, 16 Oct 2012 14:53:19 +0200

samba4 (4.0.0~rc2+dfsg1-2) experimental; urgency=low

  * Depend on at least ldb 1.1.12. Closes: #689594
  * Suggest ntp daemon for ntpsignd integration.
  * Support specifying 'none' as server role to disable provision.
    Closes: #690138
  * Prompt user for administrator password. Closes: #690139
  * Bump debconf level of server role to 'high'.

 -- Jelmer Vernooij <jelmer@debian.org>  Thu, 04 Oct 2012 13:22:40 +0200

samba4 (4.0.0~rc2+dfsg1-1) experimental; urgency=low

  * New upstream release.

 -- Jelmer Vernooij <jelmer@debian.org>  Tue, 25 Sep 2012 03:34:08 +0200

=== debian/control ===
Source: samba4
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Samba Debian Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
           Christian Perrier <bubulle@debian.org>,
           Noèl Köthe <noel@debian.org>,
           Steinar H. Gunderson <sesse@debian.org>,
           Jelmer Vernooij <jelmer@debian.org>
Homepage: http://www.samba.org/
Standards-Version: 3.9.3
Build-Depends: bison,
               comerr-dev,
               debhelper (>> 9),
               docbook-xml,
               docbook-xsl,
               flex,
               heimdal-multidev (>= 1.6~),
               libattr1-dev,
               libacl1-dev,
               libblkid-dev,
               libbsd-dev,
               libgnutls-dev,
               libheimntlm0-heimdal (>= 1.6~),
               libldap2-dev,
               libldb-dev (>= 1:1.1.13~),
               libpam0g-dev,
               libparse-yapp-perl,
               libpopt-dev,
               libreadline-dev,
               libsmbclient-dev,
               libsubunit-dev,
               libtalloc-dev (>= 2.0.7~),
               libtdb-dev (>= 1.2.10~),
               libtevent-dev (>= 0.9.17~),
               libwbclient-dev,
               perl,
               perl-modules,
               pkg-config,
               po-debconf,
               python-all-dev (>= 2.6.6-3),
               python-dnspython,
               python-ldb (>= 1:1.1.13~),
               python-ldb-dev (>= 1:1.1.13~),
               python-talloc-dev (>= 2.0.7~),
               python-tdb (>= 1.2.10~),
               python-testtools,
               samba-common (>= 2:3.4.0~pre2),
               subunit (>= 0.0.6),
               xsltproc,
               zlib1g-dev (>= 1:1.2.3)
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-samba/samba4.git
Vcs-Git: git://git.debian.org/pkg-samba/samba4
XS-Testsuite: autopkgtest

Package: samba4
Architecture: any
Recommends: attr, bind9 (>= 1:9.5.1), bind9utils, ldb-tools
Suggests: phpldapadmin, samba-gtk, swat2, ntp
Enhances: ntp, bind9
Conflicts: samba (<< 2:3.3.0~rc2-5), samba-tools
Replaces: libsamdb0 (<< 4.0.0~alpha17~)
Depends: python,
         python-dnspython,
         python-samba,
         samba-dsdb-modules,
         samba4-common-bin (=${binary:Version}),
         tdb-tools,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Description: SMB/CIFS file, NT domain and active directory server (version 4)
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains the main daemon.

Package: libsamdb0
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Depends: ${ldb:Depends}, ${misc:Depends}, ${shlibs:Depends}
Conflicts: samba-ldb-tools
Replaces: samba-ldb-tools
Recommends: samba-dsdb-modules
Description: SAM database
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the library for accessing the SAM database.

Package: libsamdb-dev
Architecture: any
Section: libdevel
Depends: libsamdb0 (=${binary:Version}), pkg-config, ${misc:Depends}
Description: SAM database - development files
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the files required for development.

Package: libsamba-policy0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${ldb:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Samba policy management
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the library for policy management.

Package: libsamba-policy-dev
Architecture: any
Section: libdevel
Depends: libsamba-policy0 (=${binary:Version}), pkg-config, ${misc:Depends}
Description: Samba policy management - development files
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the files required for development using the policy
 management library.

Package: samba4-common-bin
Architecture: any
Depends: python-samba (= ${binary:Version}),
         samba-common (>= 2:3.4.0~pre2-1),
         ${misc:Depends},
         ${python:Depends}
Conflicts: samba (<< 2:3.3.0~rc2-5), samba-common (<< 2:3.3.0~rc2-5)
Replaces: samba-common (<< 2:3.4.0~pre2-1), samba4-common (<< 4.0.0~alpha7-1)
Description: Samba 4 common files used by both the server and the client
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the samba-clients
 package).

Package: samba4-clients
Architecture: any
Depends: samba4-common-bin (=${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         smbclient
Conflicts: samba-common (<< 2:3.3.0~rc2-5)
Description: client utilities from Samba 4
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This package contains some client components of the Samba suite. In
 particular it includes the command line utilities smbclient, net,
 and some ACL tools.

Package: samba4-testsuite
Architecture: any
Conflicts: samba-tools
Recommends: subunit
Depends: samba4-common-bin, ${misc:Depends}, ${shlibs:Depends}
Description: test suite from Samba 4
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: tools for viewing and manipulating the Windows registry
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: libparse-pidl-perl
Architecture: any
Depends: libparse-yapp-perl, ${misc:Depends}, ${perl:Depends}
Recommends: libdcerpc-dev
Section: perl
Description: IDL compiler written in Perl
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 This package contains the IDL (Interface Description Language) compiler pidl,
 which takes in IDL files and can output C code for various uses. It is
 primarily of interest to developers.

Package: samba4-dev
Architecture: any
Depends: libc6-dev,
         libldb-dev,
         libparse-pidl-perl,
         libpopt-dev,
         libtalloc-dev,
         libtdb-dev (>= 1.1.0),
         ${misc:Depends}
Section: devel
Description: tools for extending Samba
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains include files shared by the various Samba-based
 libraries.

Package: libgensec0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: samba-common (>= 2:3.4.0~pre2-1), ${misc:Depends}, ${shlibs:Depends}
Replaces: winbind4 (<< 4.0.0~alpha17~git20110724.dfsg1-1)
Description: Generic Security Library
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This library provides a generalized API for several security protocols.

Package: libgensec-dev
Architecture: any
Section: libdevel
Replaces: samba4-dev (<< 4.0.0~alpha17~)
Depends: libgensec0 (=${binary:Version}), pkg-config, ${misc:Depends}
Description: Generic Security Library
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This library provides a generalized API for several security protocols.
 .
 This package contains the files required for development.

Package: libndr0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: NDR marshalling library
 Samba is an implementation of the SMB/CIFS protocol for Unix systems,
 providing support for cross-platform file sharing with Microsoft Windows, OS X,
 and other Unix systems.  Samba can also function as a domain controller
 or member server in both NT4-style and Active Directory domains.
 .

=== debian/rules ===
#!/usr/bin/make -f
# By Jelmer Vernooij <jelmer@samba.org>
#
DESTDIR = $(CURDIR)/debian/tmp

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

PYVERS=$(shell pyversions -vr)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LDB_VERSION = $(shell pkg-config --modversion ldb)
LDB_NEXT_VERSION = $(shell python -c "x = '$(LDB_VERSION)'.split('.'); x[-1] = str(int(x[-1])+1); print '.'.join(x)")
LDB_DEPENDS = "libldb1 (<< 1:$(LDB_NEXT_VERSION)~), libldb1 (>> 1:$(LDB_VERSION)~)"
export PYTHON=$(shell which `pyversions -d`)
export PYTHON_CONFIG="$(PYTHON)-config"
WAF = $(PYTHON) ./buildtools/bin/waf

# turn DEB_BUILD_OPTIONS='foo,bar' into DEB_BUILD_OPT_FOO and DEB_BUILD_OPT_BAR
d_b_o:=$(shell echo "$$DEB_BUILD_OPTIONS"|sed 's/[^-[:alnum:]]/ /g'|tr a-z A-Z)
$(foreach o, $(d_b_o), $(eval DEB_BUILD_OPT_$o := 1))

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
WAF += -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

%:
	dh $* --with python2

override_dh_auto_configure:
	$(shell dpkg-buildflags --export=configure) $(WAF) configure \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--with-piddir=/var/run \
		--with-modulesdir=/usr/lib/$(DEB_HOST_MULTIARCH)/samba/ \
		--disable-rpath \
		--disable-ntdb \
		--disable-rpath-install \
		--bundled-libraries=NONE,pytevent,iniparser \
		--builtin-libraries=replace,ccan \
		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--enable-fhs

override_dh_auto_clean:
	-$(WAF) clean
	rm -f debian/*.upstart
	find . -name "*.pyc" | xargs rm -f
	rm -rf buildtools/bin/.waf-*

override_dh_auto_install:
	DESTDIR="$(DESTDIR)" $(WAF) install

override_dh_auto_build:
	DESTDIR="$(DESTDIR)" $(WAF)

override_dh_auto_test:
	# Running make test requires configuration with --enable-selftest, which
	# we don't want to do for production systems.

override_dh_install:
	# Alternatives are used
	# Already provided by libparse-yapp-perl
	rm $(DESTDIR)/usr/share/perl5/Parse/Yapp/Driver.pm
	# Already shipped in samba-common
	rm $(DESTDIR)/usr/share/samba/codepages/*.dat
	# Binaries not ready for installation
	rm $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/mit_samba.so
	# Included in python-tevent
	rm $(DESTDIR)/usr/lib/python*/*-packages/_tevent.so
	rm $(DESTDIR)/usr/lib/python*/*-packages/tevent.py
	# Already included in various system packages
	rm -r $(DESTDIR)/usr/lib/python*/*-packages/samba/external
	# Already documented in debian/copyright
	rm $(DESTDIR)/usr/share/samba/setup/ad-schema/licence.txt
	# System ldb loads its modules from a different path
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb
	ln -sf ../../../samba/ldb $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules/ldb/samba
	mkdir -p $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/security
	mkdir -p $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/security/pam_winbind.so $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/security/pam_winbind.so
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libnss_winbind.so* $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)
	rm $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/samba/share/ldb.so
	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/plugin/krb5
	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/winbind_krb5_locator.so \
	   $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/plugin/krb5
	install -m 0755 debian/setoption.py $(DESTDIR)/usr/share/samba
	install -m 0755 debian/addshare.py $(DESTDIR)/usr/share/samba
	# Remove Samba 3 files for now
	while read line; \
	do \
		rm -r $(DESTDIR)$$line; \
	done < debian/samba3-files
	rm -f $(DESTDIR)/usr/share/man/man8/vfs_*.8
	while read line; \
	do \
		rm -r $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/$$line; \
	done < debian/samba3-files-lib
	dh_install --sourcedir=$(DESTDIR) --list-missing --fail-missing

override_dh_python2:
	dh_python2 --no-guessing-versions

get-packaged-orig-source:
	./debian/build-orig.sh

override_dh_installdocs:
	dh_installdocs source4/NEWS

override_dh_shlibdeps:
	LD_LIBRARY_PATH=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/samba:$$LD_LIBRARY_PATH dh_shlibdeps -a

override_dh_gencontrol:
	dh_gencontrol -a -- -Vldb:Depends=$(LDB_DEPENDS)

override_dh_makeshlibs:
	dh_makeshlibs -X/usr/lib/$(DEB_HOST_MULTIARCH)/samba -X/usr/lib/$(DEB_HOST_MULTIARCH)/plugin

override_dh_installinit:
	if dpkg-vendor --derives-from ubuntu; then \
		cp debian/samba4.upstart.in debian/samba4.upstart; \
		dh_installinit --upstart-only; \
	else \
		dh_installinit; \
	fi;

=== debian/watch ===
version=2
opts="uversionmangle=s/tp/~alpha1~tp/;s/alpha/~alpha/;s/beta/~beta/;s/rc/~rc/,dversionmangle=s/\+dfsg\d+$//" \
	  ftp://ftp.samba.org/pub/samba/rc/samba-(.*).tar.gz

## samba4 4.0.0+dfsg1

=== lib/tdb/wscript ===
#!/usr/bin/env python

APPNAME = 'tdb'
VERSION = '1.2.10'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options, Logs

samba_dist.DIST_DIRS('lib/tdb:. lib/replace:lib/replace buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('tdb', noextension='tdb')
    opt.RECURSE('lib/replace')
    if opt.IN_LAUNCH_DIR():
        opt.add_option('--disable-python',
                       help=("disable the pytdb module"),
                       action="store_true", dest='disable_python', default=False)


def configure(conf):
    conf.RECURSE('lib/replace')

    conf.env.standalone_tdb = conf.IN_LAUNCH_DIR()
    conf.env.building_tdb = True

    if not conf.env.standalone_tdb:
        if conf.CHECK_BUNDLED_SYSTEM_PKG('tdb', minversion=VERSION,
                                     implied_deps='replace'):
            conf.define('USING_SYSTEM_TDB', 1)
            conf.env.building_tdb = False
            if conf.CHECK_BUNDLED_SYSTEM_PYTHON('pytdb', 'tdb', minversion=VERSION):
                conf.define('USING_SYSTEM_PYTDB', 1)

    conf.env.disable_python = getattr(Options.options, 'disable_python', False)

    conf.CHECK_XSLTPROC_MANPAGES()

    if not conf.env.disable_python:
        # also disable if we don't have the python libs installed
        conf.find_program('python', var='PYTHON')
        conf.check_tool('python')
        conf.check_python_version((2,4,2))
        conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=False)
        if not conf.env.HAVE_PYTHON_H:
            Logs.warn('Disabling pytdb as python devel libs not found')
            conf.env.disable_python = True

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

def build(bld):
    bld.RECURSE('lib/replace')

    COMMON_SRC = bld.SUBDIR('common',
                            '''check.c error.c tdb.c traverse.c
                            freelistcheck.c lock.c dump.c freelist.c
                            io.c open.c transaction.c hash.c summary.c''')

    if bld.env.standalone_tdb:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        private_library = False
    else:
        private_library = True

    if not bld.CONFIG_SET('USING_SYSTEM_TDB'):
        bld.SAMBA_LIBRARY('tdb',
                          COMMON_SRC,
                          deps='replace',
                          includes='include',
                          abi_directory='ABI',
                          abi_match='tdb_*',
                          hide_symbols=True,
                          vnum=VERSION,
                          public_headers='include/tdb.h',
                          public_headers_install=not private_library,
                          pc_files='tdb.pc',
                          private_library=private_library)

        bld.SAMBA_BINARY('tdbtorture',
                         'tools/tdbtorture.c',
                         'tdb',
                         install=False)

        bld.SAMBA_BINARY('tdbrestore',
                         'tools/tdbrestore.c',
                         'tdb', manpages='man/tdbrestore.8')

        bld.SAMBA_BINARY('tdbdump',
                         'tools/tdbdump.c',
                         'tdb', manpages='man/tdbdump.8')

        bld.SAMBA_BINARY('tdbbackup',
                         'tools/tdbbackup.c',
                         'tdb',
                         manpages='man/tdbbackup.8')

        bld.SAMBA_BINARY('tdbtool',
                         'tools/tdbtool.c',
                         'tdb', manpages='man/tdbtool.8')

        # FIXME: This hardcoded list is stupid, stupid, stupid.
        bld.SAMBA_SUBSYSTEM('tdb-test-helpers',
                            'test/external-agent.c test/lock-tracking.c test/logging.c',
                            'replace',
                            includes='include')

        bld.SAMBA_BINARY('tdb1-run-3G-file', 'test/run-3G-file.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-bad-tdb-header', 'test/run-bad-tdb-header.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run', 'test/run.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-check', 'test/run-check.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-corrupt', 'test/run-corrupt.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-die-during-transaction', 'test/run-die-during-transaction.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-endian', 'test/run-endian.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-incompatible', 'test/run-incompatible.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-nested-transactions', 'test/run-nested-transactions.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-nested-traverse', 'test/run-nested-traverse.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-no-lock-during-traverse', 'test/run-no-lock-during-traverse.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-oldhash', 'test/run-oldhash.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-open-during-transaction', 'test/run-open-during-transaction.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-readonly-check', 'test/run-readonly-check.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-rwlock-check', 'test/run-rwlock-check.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-summary', 'test/run-summary.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-transaction-expand', 'test/run-transaction-expand.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-traverse-in-transaction', 'test/run-traverse-in-transaction.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-wronghash-fail', 'test/run-wronghash-fail.c',
                         'replace tdb-test-helpers', includes='include', install=False)
        bld.SAMBA_BINARY('tdb1-run-zero-append', 'test/run-zero-append.c',
                         'replace tdb-test-helpers', includes='include', install=False)

    if not bld.CONFIG_SET('USING_SYSTEM_PYTDB'):
        bld.SAMBA_PYTHON('pytdb',
                         'pytdb.c',
                         deps='tdb',
                         enabled=not bld.env.disable_python,
                         realname='tdb.so',
                         cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

def testonly(ctx):
    '''run tdb testsuite'''
    import Utils, samba_utils, shutil
    ecode = 0

    test_prefix = "%s/st" % (Utils.g_module.blddir)
    shutil.rmtree(test_prefix, ignore_errors=True)
    os.makedirs(test_prefix)
    os.environ['TEST_DATA_PREFIX'] = test_prefix

    env = samba_utils.LOAD_ENVIRONMENT()
    # FIXME: This is horrible :(
    if env.building_tdb:
        # Create scratch directory for tests.
        testdir = os.path.join(test_prefix, 'tdb-tests')
        samba_utils.mkdir_p(testdir)
        # Symlink back to source dir so it can find tests in test/
        link = os.path.join(testdir, 'test')
        if not os.path.exists(link):
            os.symlink(os.path.abspath(os.path.join(env.cwd, 'test')), link)

        for f in 'tdb1-run-3G-file', 'tdb1-run-bad-tdb-header', 'tdb1-run', 'tdb1-run-check', 'tdb1-run-corrupt', 'tdb1-run-die-during-transaction', 'tdb1-run-endian', 'tdb1-run-incompatible', 'tdb1-run-nested-transactions', 'tdb1-run-nested-traverse', 'tdb1-run-no-lock-during-traverse', 'tdb1-run-oldhash', 'tdb1-run-open-during-transaction', 'tdb1-run-readonly-check', 'tdb1-run-rwlock-check', 'tdb1-run-summary', 'tdb1-run-transaction-expand', 'tdb1-run-traverse-in-transaction', 'tdb1-run-wronghash-fail', 'tdb1-run-zero-append':
            cmd = "cd " + testdir + " && " + os.path.abspath(os.path.join(Utils.g_module.blddir, f)) + " > test-output 2>&1"
            print("..." + f)
            ret = samba_utils.RUN_COMMAND(cmd)
            if ret != 0:
                print("%s failed:" % f)
                samba_utils.RUN_COMMAND("cat " + os.path.join(testdir, 'test-output'))
                ecode = ret
                break

    if ecode == 0:
        cmd = os.path.join(Utils.g_module.blddir, 'tdbtorture')
        ret = samba_utils.RUN_COMMAND(cmd)
        print("testsuite returned %d" % ret)
        if ret != 0:
            ecode = ret
    sys.exit(ecode)

# WAF doesn't build the unit tests for this, maybe because they don't link with tdb?
# This forces it
def test(ctx):
    import Scripting
    Scripting.commands.append('build')
    Scripting.commands.append('testonly')

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)

=== debian/changelog ===
samba4 (4.0.0+dfsg1-1ubuntu1) raring; urgency=low

  * d/p/underlinking: link samba4kpasswd and samba4kgetcred with -lasn1 to fix
    FTBFS.

 -- Robie Basak <robie.basak@canonical.com>  Wed, 10 Apr 2013 14:11:42 +0000

samba4 (4.0.0+dfsg1-1) experimental; urgency=low

  [ Martin Pitt ]
  * debian/tests/control: Fix dependency: python-samba4 does not exist, it's
    python-samba. Closes: #695854

  [ Jelmer Vernooij ]
  * New upstream release: 4.0.0!
   + Add 08_waf_python_config to cope with python-config no longer
     being a script.
  * Add 25_heimdal_api_changes, to update Samba to work with the
    current Heimdal in Sid. Patch from
    Samuel Cabrero Alamán <scabrero@zentyal.com>. Closes: #686227
  * Add 11_force_ntvfs: Force the use of NTVFS, until the version of smbd in
    the archive is new enough. Closes: #694697
  * Drop dependency on libsmbclient; instead, build private copy.

 -- Jelmer Vernooij <jelmer@debian.org>  Thu, 13 Dec 2012 16:27:20 +0100

samba4 (4.0.0~rc6+dfsg1-1) experimental; urgency=low

  * New upstream release.
   + Drop 08_heimdal_config_h and 11_system_heimdal, now applied upstream.

 -- Jelmer Vernooij <jelmer@debian.org>  Tue, 04 Dec 2012 14:39:40 +0100

=== debian/control ===
--- 
+++ 
@@ -29,7 +29,6 @@
                libparse-yapp-perl,
                libpopt-dev,
                libreadline-dev,
-               libsmbclient-dev,
                libsubunit-dev,
                libtalloc-dev (>= 2.0.7~),
                libtdb-dev (>= 1.2.10~),

=== debian/rules ===
--- 
+++ 
@@ -39,6 +39,7 @@
 		--disable-rpath-install \
 		--bundled-libraries=NONE,pytevent,iniparser \
 		--builtin-libraries=replace,ccan \
+		--private-libraries=smbclient \
 		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
 		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
 		--enable-fhs
@@ -82,6 +83,8 @@
 	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/security/pam_winbind.so $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/security/pam_winbind.so
 	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libnss_winbind.so* $(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)
 	rm $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/samba/share/ldb.so
+	rm -r $(DESTDIR)/usr/share/samba/codepages/ru
+	rm $(DESTDIR)/usr/share/samba/codepages/*.msg
 	mkdir -p $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/plugin/krb5
 	mv $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/winbind_krb5_locator.so \
 	   $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/plugin/krb5

=== debian/watch ===
version=2
opts="uversionmangle=s/tp/~alpha1~tp/;s/alpha/~alpha/;s/beta/~beta/;s/rc/~rc/,dversionmangle=s/\+dfsg\d+$//" \
	  ftp://ftp.samba.org/pub/samba/samba-(.*).tar.gz
